/* Problem URL: https://codeforces.com/gym/104114/problem/G */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vl fds(n);
    cin >> fds;

    vl diffs(n - 1);

    rep(i, n - 1) {
        diffs[i] = abs(fds[i] - fds[i + 1]);
    }

    vl ans(n);
    nrep(i, 1, n) {
        ans[i] = diffs[i - 1] - ans[i - 1];
    }

    map<ll, int> count;
    rep(i, n) {
        ll n;
        cin >> n;
        count[n]++;
    }

    ll oo = INT64_MAX >> 1;
    ll minimal_odd = oo;
    ll odd_i = 0;
    ll minimal_ev = oo;
    ll ev_i = 0;

    rep(i, n) {
        if (i & 1) {
            if (ans[i] < minimal_odd) {
                minimal_odd = ans[i];
                odd_i = i;
            }
            continue;
        }

        if (ans[i] < minimal_ev) {
            minimal_ev = ans[i];
            ev_i = i;
        }
    }

    auto check_k = [&](ll k) {
        rep(i, n) {
            ll now = 0;
            if (i & 1) {
                now = ans[i] - k;
            } else {
                now = ans[i] + k;
            }

            if (count[now] == 0) {
                return false;
            }
            count[now]--;
        }

        return true;
    };

    ll act = count.begin()->first;

    ll k = -(ans[ev_i] - act);
    if (!check_k(k)) {
        k = ans[odd_i] - act;
    }

    rep(i, n) {
        if (i & 1) {
            cout << ans[i] - k;
        } else {
            cout << ans[i] + k;
        }

        cout << " \n"[i == n - 1];
    }
}
